/*
Copyright 2014 Kai Ryu <kai1103@gmail.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <avr/pgmspace.h>
#include "ledmap.h"


#ifdef LEDMAP_ENABLE

static const uint8_t ledmaps[LED_COUNT] PROGMEM = {
    [0] = LEDMAP_BACKLIGHT,
    [1] = LEDMAP_BACKLIGHT,
    [2] = LEDMAP_BACKLIGHT,
    [3] = LEDMAP_BACKLIGHT
};

uint8_t ledmap_get_code(uint8_t index)
{
    return pgm_read_byte(&ledmaps[index]);
}

void ledmap_led_init(void)
{
    DDRD |= (1<<PD0);
    DDRB |= (1<<PB7);
    DDRC |= (1<<PD5 | 1<<PD6);
}

void ledmap_led_on(uint8_t index)
{
    switch (index) {
        case 0:
            PORTD |= (1<<PD0);
            break;
        case 1:
            PORTB |= (1<<PB7);
            break;
        case 2:
            PORTC |= (1<<PC6);
            break;
        case 3:
            PORTC |= (1<<PC5);
            break;
    }
}

void ledmap_led_off(uint8_t index)
{
    switch (index) {
        case 0:
            PORTD &= ~(1<<PD0);
            break;
        case 1:
            PORTB &= ~(1<<PB7);
            break;
        case 2:
            PORTC &= ~(1<<PC6);
            break;
        case 3:
            PORTC &= ~(1<<PC5);
            break;
    }
}

#endif
